<?php
class ControllerExtensionModuleSoreviewslider extends Controller {
	public function index($setting) {
		$this->load->language('extension/module/so_review_slider');
		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_tax'] = $this->language->get('text_tax');
		
		$this->load->model('extension/module/so_review_slider');	

		$this->document->addStyle('catalog/view/javascript/so_review_slider/css/style.css');
		$this->document->addStyle('catalog/view/javascript/so_review_slider/css/css3.css');
		if (!defined ('OWL_CAROUSEL'))
		{
			$this->document->addStyle('catalog/view/javascript/so_review_slider/css/animate.css');
			$this->document->addStyle('catalog/view/javascript/so_review_slider/css/owl.carousel.css');
			$this->document->addScript('catalog/view/javascript/so_review_slider/js/owl.carousel.js');
			define( 'OWL_CAROUSEL', 1 );
		}
		
		$filter_data = array(
		    'order'             => 'DESC',
            'start'             => 0,
			'limit'             => $setting['source_limit'],
		);

		$default = array(
			'objlang'				=> $this->language,
			'name' 					=> '',
			'module_description'	=> array(),
			'disp_title_module'		=> '1',
			'status'				=> '1',
			'class_suffix'			=> '',
			'item_link_target'		=> '_blank',
			'showName'              => '1',
			'showCommentator'       => '1',
			'showCommentContent'    => '1',
			'showRating'            => '1',
			'nb_column0'			=> '4',
			'nb_column1'			=> '4',
			'nb_column2'			=> '3',
			'nb_column3'			=> '2',
			'nb_column4'			=> '1',
			'nb_row'				=> '1',
			'source_limit'			=> '6',
			'limitedCharactersCommentContent' => '200',
						
			'margin'				=> '5',
			'slideBy'				=> '1',
			'autoplay'				=> '0',
			'autoplayTimeout'		=> '5000',
			'autoplayHoverPause'	=> '0',
			'autoplaySpeed'			=> '1000',
			'smartSpeed'			=> '1000',
			'startPosition'			=> '0',
			'mouseDrag'				=> '1',
			'touchDrag'				=> '1',
			'pullDrag'				=> '1',
			'button_page' 			=> 'top',
			'dots'					=> '1',
			'dotsSpeed'				=> '500',
			'loop'					=> '1',
			'navs'					=> '1',
			'navSpeed'				=> '500',
			'effect'				=> 'starwars',
			'duration'				=> '800',
			'delay'					=> '500',
			'store_layout'			=> 'default',
			'post_text'				=> '',
			'pre_text'				=> '',
			'use_cache'				=> '1',
			'cache_time'			=> '3600',
			'direction'				=> ($this->language->get('direction') == 'rtl' ? 'true' : 'false'),
			'direction_class'		=> ($this->language->get('direction') == 'rtl' ? 'so-reviewslider-rtl' : 'so-reviewslider-ltr')
		);

		$data = array_merge($default,$setting);
        $data['reviews'] = $this->model_extension_module_so_review_slider->getReviews($filter_data);		
		foreach ($data['reviews'] as $key => $item) {
			$review_info = $this->model_extension_module_so_review_slider->getReview($item['review_id']);	
            $data['reviews'][$key]['href'] =  $this->url->link('product/product', 'product_id=' . $review_info['product_id']);			
			$data['reviews'][$key]['text'] = (($setting['limitedCharactersCommentContent'] != 0 && strlen($review_info['text']) > $setting['limitedCharactersCommentContent'] ) ? utf8_substr(strip_tags(html_entity_decode($review_info['text'], ENT_QUOTES, 'UTF-8')), 0, $setting['limitedCharactersCommentContent']) . '...' : $review_info['text']);			
			$data['reviews'][$key]['author'] = (($setting['limitedCharactersCommentator'] != 0 && strlen($review_info['author']) > $setting['limitedCharactersCommentator'] ) ? utf8_substr(strip_tags(html_entity_decode($review_info['author'], ENT_QUOTES, 'UTF-8')), 0, $setting['limitedCharactersCommentator']) . '...' : $review_info['author']);
			$data['reviews'][$key]['product'] = $review_info['product'];			
		}
		
		if (isset($setting['module_description'][$this->config->get('config_language_id')])) {
			$data['head_name'] = html_entity_decode($setting['module_description'][$this->config->get('config_language_id')]['head_name'], ENT_QUOTES, 'UTF-8');
		}else{
			$data['head_name']  = $setting['head_name'];
		}		
		
		
		$data['moduleid']  = $setting['moduleid'];
		$data['disp_title_module'] = (int)$setting['disp_title_module'];
		$data['autoplay'] = $setting['autoplay'];
		if ($data['autoplay'] == 1) {
			$data['autoplayTimeout'] = $setting['autoplayTimeout'];
		}else{
			$data['autoplayTimeout'] = 0;
		}
		$data['dots'] 	= ($setting['dots'] == 1) ? "true" : "false";
		$data['loop'] 					= ($setting['loop'] == 1 ? "true" : "false");
		$data['nav'] 					= ($setting['navs'] == 1 ? "true" : "false");
		$data['nb_rows'] = $setting['nb_row'];
		$data['count'] = $setting['source_limit'];
		
		
		// caching
		$use_cache = (int)$setting['use_cache'];
		$cache_time = (int)$setting['cache_time'];
		$folder_cache = DIR_CACHE.'so/ReviewSlider/';
		if(!file_exists($folder_cache))
			mkdir ($folder_cache, 0777, true);
		if (!class_exists('Cache_Lite'))
			require_once (DIR_SYSTEM . 'library/so/review_slider/Cache_Lite/Lite.php');

		$options = array(
			'cacheDir' => $folder_cache,
			'lifeTime' => $cache_time
		);
		$Cache_Lite = new Cache_Lite($options);
		if ($use_cache){
			$this->hash = md5( serialize($setting));
			$_data = $Cache_Lite->get($this->hash);
			if (!$_data) {
				$_data = $this->load->view('extension/module/so_review_slider/'.$setting['store_layout'], $data);
				$Cache_Lite->save($_data);
				return  $_data;
			} else {
				return  $_data;
			}
		}else{
			if(file_exists($folder_cache))
				$Cache_Lite->_cleanDir($folder_cache);
			return $this->load->view('extension/module/so_review_slider/'.$setting['store_layout'], $data);
		}
				
	}
}